- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- Alphabetical List
- Data Structures
- Class Hierarchy
- Data Fields

# StringEnumeration Class Reference

Base class for 'pure' C++ implementations of uenum api. More...

`#include <strenum.h>`

Inheritance diagram for StringEnumeration:

## Public Member Functions
virtual | ~StringEnumeration ()
| Destructor.
virtual StringEnumeration * | clone () const
| Clone this object, an instance of a subclass of StringEnumeration.
virtual int32_t | count (UErrorCode &status) const=0
virtual const char * | next (int32_t *resultLength, UErrorCode &status)
virtual const UChar * | unext (int32_t *resultLength, UErrorCode &status)
virtual const UnicodeString * | snext (UErrorCode &status)=0
virtual void | reset (UErrorCode &status)=0
virtual UBool | operator== (const StringEnumeration &that) const
| Compares this enumeration to other to check if both are equal.
virtual UBool | operator!= (const StringEnumeration &that) const
| Compares this enumeration to other to check if both are not equal.
## Protected Member Functions
| StringEnumeration ()
| Default constructor for use with default implementations and subclasses.
void | ensureCharsCapacity (int32_t capacity, UErrorCode &status)
| Ensures that chars is at least as large as the requested capacity.
UnicodeString * | setChars (const char *s, int32_t length, UErrorCode &status)
| Converts s to Unicode and sets unistr to the result.
## Protected Attributes
UnicodeString | unistr
| UnicodeString field for use with default implementations and subclasses.
char | charsBuffer [32]
| char * default buffer for use with default implementations and subclasses.
char * | chars
| char * buffer for use with default implementations and subclasses.
int32_t | charsCapacity
| Capacity of chars, for use with default implementations and subclasses.

## Detailed Description

Base class for 'pure' C++ implementations of uenum api.

Adds a method that returns the next UnicodeString since in C++ this can be a common storage format for strings.

The model is that the enumeration is over strings maintained by a 'service.' At any point, the service might change, invalidating the enumerator (though this is expected to be rare). The iterator returns an error if this has occurred. Lack of the error is no guarantee that the service didn't change immediately after the call, so the returned string still might not be 'valid' on subsequent use.

Strings may take the form of const char*, const UChar*, or const UnicodeString*. The type you get is determine by the variant of 'next' that you call. In general the StringEnumeration is optimized for one of these types, but all StringEnumerations can return all types. Returned strings are each terminated with a NUL. Depending on the service data, they might also include embedded NUL characters, so API is provided to optionally return the true length, counting the embedded NULs but not counting the terminating NUL.

The pointers returned by next, unext, and snext become invalid upon any subsequent call to the enumeration's destructor, next, unext, snext, or reset.

ICU 2.8 adds some default implementations and helper functions for subclasses.

Stable:
  ICU 2.4

Definition at line 55 of file strenum.h.

## Constructor & Destructor Documentation

virtual StringEnumeration::~StringEnumeration | ( |  | ) | `[virtual]`

Destructor.

Stable:
  ICU 2.4

StringEnumeration::StringEnumeration | ( |  | ) | `[protected]`

Default constructor for use with default implementations and subclasses.

Stable:
  ICU 2.8

## Member Function Documentation

virtual StringEnumeration* StringEnumeration::clone | ( |  | ) | const`[virtual]`

Clone this object, an instance of a subclass of StringEnumeration.

Clones can be used concurrently in multiple threads. If a subclass does not implement clone(), or if an error occurs, then NULL is returned. The clone functions in all subclasses return a base class pointer because some compilers do not support covariant (same-as-this) return types; cast to the appropriate subclass if necessary. The caller must delete the clone.

Returns:
  a clone of this object

See also:
  getDynamicClassID

Stable:
  ICU 2.8

virtual int32_t StringEnumeration::count | ( | UErrorCode & | status | ) | const`[pure virtual]`

Return the number of elements that the iterator traverses. If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR, and the return value is zero.

The return value will not change except possibly as a result of a subsequent call to reset, or if the iterator becomes out of sync.

This is a convenience function. It can end up being very expensive as all the items might have to be pre-fetched (depending on the storage format of the data being traversed).

Parameters:

  | status | the error code.

Returns:
  number of elements in the iterator.

Stable:
  ICU 2.4

virtual const char* StringEnumeration::next | ( | int32_t * | resultLength,
|  | UErrorCode & | status |
| ) |  |  | `[virtual]`

Returns the next element as a NUL-terminated char*. If there are no more elements, returns NULL. If the resultLength pointer is not NULL, the length of the string (not counting the terminating NUL) is returned at that address. If an error status is returned, the value at resultLength is undefined.

The returned pointer is owned by this iterator and must not be deleted by the caller. The pointer is valid until the next call to next, unext, snext, reset, or the enumerator's destructor.

If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR and NULL is returned.

If the native service string is a UChar* string, it is converted to char* with the invariant converter. If the conversion fails (because a character cannot be converted) then status is set to U_INVARIANT_CONVERSION_ERROR and the return value is undefined (though not NULL).

Starting with ICU 2.8, the default implementation calls snext() and handles the conversion.

Parameters:

  | status | the error code.
  | resultLength | a pointer to receive the length, can be NULL.

Returns:
  a pointer to the string, or NULL.

Stable:
  ICU 2.4

virtual const UChar* StringEnumeration::unext | ( | int32_t * | resultLength,
|  | UErrorCode & | status |
| ) |  |  | `[virtual]`

Returns the next element as a NUL-terminated UChar*. If there are no more elements, returns NULL. If the resultLength pointer is not NULL, the length of the string (not counting the terminating NUL) is returned at that address. If an error status is returned, the value at resultLength is undefined.

The returned pointer is owned by this iterator and must not be deleted by the caller. The pointer is valid until the next call to next, unext, snext, reset, or the enumerator's destructor.

If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR and NULL is returned.

Starting with ICU 2.8, the default implementation calls snext() and handles the conversion.

Parameters:

  | status | the error code.
  | resultLength | a ponter to receive the length, can be NULL.

Returns:
  a pointer to the string, or NULL.

Stable:
  ICU 2.4

virtual const UnicodeString* StringEnumeration::snext | ( | UErrorCode & | status | ) | `[pure virtual]`

Returns the next element a UnicodeString*. If there are no more elements, returns NULL.

The returned pointer is owned by this iterator and must not be deleted by the caller. The pointer is valid until the next call to next, unext, snext, reset, or the enumerator's destructor.

If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR and NULL is returned.

Parameters:

  | status | the error code.

Returns:
  a pointer to the string, or NULL.

Stable:
  ICU 2.4

virtual void StringEnumeration::reset | ( | UErrorCode & | status | ) | `[pure virtual]`

Resets the iterator. This re-establishes sync with the service and rewinds the iterator to start at the first element.

Previous pointers returned by next, unext, or snext become invalid, and the value returned by count might change.

Parameters:

  | status | the error code.

Stable:
  ICU 2.4

virtual UBool StringEnumeration::operator== | ( | const StringEnumeration & | that | ) | const`[virtual]`

Compares this enumeration to other to check if both are equal.

Parameters:

  | that | The other string enumeration to compare this object to

Returns:
  TRUE if the enumerations are equal. FALSE if not.

Stable:
  ICU 3.6

virtual UBool StringEnumeration::operator!= | ( | const StringEnumeration & | that | ) | const`[virtual]`

Compares this enumeration to other to check if both are not equal.

Parameters:

  | that | The other string enumeration to compare this object to

Returns:
  TRUE if the enumerations are equal. FALSE if not.

Stable:
  ICU 3.6

void StringEnumeration::ensureCharsCapacity | ( | int32_t | capacity,
|  | UErrorCode & | status |
| ) |  |  | `[protected]`

Ensures that chars is at least as large as the requested capacity.

For use with default implementations and subclasses.

Parameters:

  | capacity | Requested capacity.
  | status | ICU in/out error code.

Stable:
  ICU 2.8

UnicodeString* StringEnumeration::setChars | ( | const char * | s,
|  | int32_t | length,
|  | UErrorCode & | status |
| ) |  |  | `[protected]`

Converts s to Unicode and sets unistr to the result.

For use with default implementations and subclasses, especially for implementations of snext() in terms of next(). This is provided with a helper function instead of a default implementation of snext() to avoid potential infinite loops between next() and snext().

For example:

     const UnicodeString* snext(UErrorCode& status) {
       int32_t resultLength=0;
       const char *s=next(&resultLength, status);
       return setChars(s, resultLength, status);
     }

Parameters:

  | s | String to be converted to Unicode.
  | length | Length of the string.
  | status | ICU in/out error code.

Returns:
  A pointer to unistr.

Stable:
  ICU 2.8

## Field Documentation

UnicodeString StringEnumeration::unistr`[protected]`

UnicodeString field for use with default implementations and subclasses.

Stable:
  ICU 2.8

Definition at line 209 of file strenum.h.

char StringEnumeration::charsBuffer[32]`[protected]`

char * default buffer for use with default implementations and subclasses.

Stable:
  ICU 2.8

Definition at line 214 of file strenum.h.

char* StringEnumeration::chars`[protected]`

char * buffer for use with default implementations and subclasses.

Allocated in constructor and in ensureCharsCapacity().

Stable:
  ICU 2.8

Definition at line 220 of file strenum.h.

int32_t StringEnumeration::charsCapacity`[protected]`

Capacity of chars, for use with default implementations and subclasses.

Stable:
  ICU 2.8

Definition at line 225 of file strenum.h.

The documentation for this class was generated from the following file:

- strenum.h